
Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D

Class VideoDX

    Friend Red1 As Int32
    Friend Green1 As Int32
    Friend Blue1 As Int32
    Friend Red2 As Int32
    Friend Green2 As Int32
    Friend Blue2 As Int32

    Friend m_Device As Device
    Private m_Vertices As VertexBuffer
    Friend m_PresentParams As New PresentParameters()

    Friend Sub CloseAll()
        If AV1.m_Texture IsNot Nothing Then
            AV1.m_Texture.Dispose()
            AV1.m_Texture = Nothing
        End If
        If AV2.m_Texture IsNot Nothing Then
            AV2.m_Texture.Dispose()
            AV2.m_Texture = Nothing
        End If
        If m_Vertices IsNot Nothing Then
            m_Vertices.Dispose()
            m_Vertices = Nothing
        End If
        If m_Device IsNot Nothing Then
            m_Device.Dispose()
            m_Device = Nothing
        End If
    End Sub

    Friend Sub InitGraphics(ByVal ctrl As Control)
        CloseAll()
        '
        With m_PresentParams
            '.BackBufferCount = 1
            '.BackBufferFormat = Format.X8R8G8B8
            .BackBufferWidth = ctrl.Width
            .BackBufferHeight = ctrl.Height
            '.MultiSample = MultiSampleType.EightSamples
            '.MultiSampleQuality = 2
            '
            .MultiSample = MultiSampleType.None
            .Windowed = True
            .PresentationInterval = PresentInterval.Immediate
            .SwapEffect = SwapEffect.Discard
        End With
        '
        m_Device = New Direct3D.Device(0, _
                                       DeviceType.Hardware, _
                                       ctrl.Handle, _
                                       CreateFlags.SoftwareVertexProcessing, _
                                       m_PresentParams)

        m_Vertices = New VertexBuffer(GetType(CustomVertex.TransformedTextured), _
                                      4, _
                                      m_Device, _
                                      0, _
                                      CustomVertex.TransformedTextured.Format, _
                                      Pool.Default)
        '
        Dim verts As CustomVertex.TransformedTextured()
        verts = DirectCast(m_Vertices.Lock(0, 0), CustomVertex.TransformedTextured())
        verts(0) = New CustomVertex.TransformedTextured(0, 0, 0.5F, 1, 0, 0)
        verts(1) = New CustomVertex.TransformedTextured(ctrl.Width, 0, 0.5F, 1, 1, 0)
        verts(2) = New CustomVertex.TransformedTextured(0, ctrl.Height, 0.5F, 1, 0, 1)
        verts(3) = New CustomVertex.TransformedTextured(ctrl.Width, ctrl.Height, 0.5F, 1, 1, 1)
        m_Vertices.Unlock()

        'Dim verts As CustomVertex.TransformedColoredTextured()
        'verts = DirectCast(m_Vertices.Lock(0, 0), CustomVertex.TransformedColoredTextured())
        'verts(0) = New CustomVertex.TransformedColoredTextured(0, 0, 0.5F, 1, 0, 0, 0)
        'verts(1) = New CustomVertex.TransformedColoredTextured(ctrl.Width, 0, 0.5F, 1, 0, 1, 0)
        'verts(2) = New CustomVertex.TransformedColoredTextured(0, ctrl.Height, 0.5F, 1, 0, 0, 1)
        'verts(3) = New CustomVertex.TransformedColoredTextured(ctrl.Width, ctrl.Height, 0.5F, 1, 0, 1, 1)
        'm_Vertices.Unlock()
        '
        ClearDevice()
    End Sub

    Friend Sub ClearDevice()
        m_Device.Clear(ClearFlags.Target, Color.AliceBlue, 1.0F, 0)
    End Sub



    'Private Sub DX8_InitDefaultLights()
    '    Dim light1 As Light = New Light
    '    light1.Type = LightType.Point
    '    light1.Attenuation0 = 1
    '    light1.Attenuation1 = 0
    '    light1.Attenuation2 = 0
    '    light1.Falloff = 1

    '    light1.AmbientColor = New ColorValue(0, 0, 0, 0)
    '    light1.DiffuseColor = New ColorValue(0.7, 0.7, 0.7, 0)
    '    light1.SpecularColor = New ColorValue(0.5, 0.5, 0.5, 0)
    '    light1.Range = 30000
    '    light1.Position = New Vector3(5000, 5000, 5000)


    '    m_Device.Lights(0).FromLight(light1)
    '    m_Device.Lights(0).Enabled = True

    '    light1.AmbientColor = New ColorValue(0, 0, 0, 0)
    '    light1.DiffuseColor = New ColorValue(0.7, 0.7, 0.7, 0)
    '    light1.SpecularColor = New ColorValue(0.5, 0.5, 0.5, 0)
    '    light1.Range = 30000
    '    light1.Position = New Vector3(-5000, 5000, -5000)


    '    m_Device.Lights(1).FromLight(light1)
    '    m_Device.Lights(1).Enabled = True
    'End Sub

    'Private Sub MultiplyIllumination(ByRef l As Light)
    '    Dim k As Single
    '    Dim ks As Single
    '    '----------------------------------------------- il quadrato della illuminazione e' piu' graduale
    '    k = SceneProp.LightTotal * SceneProp.LightTotal
    '    ks = k * SceneProp.LightSpecular * SceneProp.LightSpecular

    '    With l
    '        .DiffuseColor = New ColorValue(.DiffuseColor.Red * k, .DiffuseColor.Green * k, .DiffuseColor.Blue * k, .DiffuseColor.Alpha)
    '        .AmbientColor = New ColorValue(.AmbientColor.Red * k, .AmbientColor.Green * k, .AmbientColor.Blue * k, .AmbientColor.Alpha)
    '        .SpecularColor = New ColorValue(.SpecularColor.Red * ks, .SpecularColor.Green * ks, .SpecularColor.Blue * ks, .SpecularColor.Alpha)
    '    End With
    'End Sub

    'Friend Sub RenderScene()
    '    If m_Device Is Nothing Then Return

    '    With m_Device
    '        .BeginScene()

    '        .SamplerState(0).MagFilter = TextureFilter.Linear

    '        .TextureState(0).ColorOperation = TextureOperation.SelectArg1
    '        .TextureState(0).ColorArgument1 = TextureArgument.TextureColor
    '        .TextureState(0).AlphaOperation = TextureOperation.SelectArg1
    '        .TextureState(0).AlphaArgument1 = TextureArgument.TextureColor

    '        If AV1.m_Texture IsNot Nothing Then
    '            .RenderState.AlphaBlendEnable = False
    '            .SetTexture(0, AV1.m_Texture)
    '            .VertexFormat = CustomVertex.TransformedTextured.Format
    '            .SetStreamSource(0, m_Vertices, 0)
    '            .DrawPrimitives(PrimitiveType.TriangleStrip, 0, 2)
    '        End If

    '        If AV2.m_Texture IsNot Nothing Then
    '            .RenderState.AlphaBlendEnable = True
    '            .RenderState.BlendOperation = BlendOperation.Add
    '            .RenderState.SourceBlend = Blend.SourceAlpha
    '            .RenderState.DestinationBlend = Blend.InvSourceAlpha
    '            .SetTexture(0, AV2.m_Texture)
    '            .VertexFormat = CustomVertex.TransformedTextured.Format
    '            .SetStreamSource(0, m_Vertices, 0)
    '            .DrawPrimitives(PrimitiveType.TriangleStrip, 0, 2)
    '        End If

    '        .EndScene()
    '        .Present()
    '    End With
    'End Sub

    Friend Sub RenderScene()
        If m_Device Is Nothing Then Return
        'DX8_InitDefaultLights()

        With m_Device
            .BeginScene()
            ' -----------------------------------------------------------------
            .SamplerState(0).MagFilter = TextureFilter.Linear
            ' ----------------------------------------------------------------- 
            .TextureState(0).ColorOperation = TextureOperation.Modulate2X
            .TextureState(0).ColorArgument1 = TextureArgument.TextureColor
            .TextureState(0).ColorArgument2 = TextureArgument.TFactor
            '.TextureState(0).AlphaOperation = TextureOperation.SelectArg1
            '.TextureState(0).AlphaArgument1 = TextureArgument.TextureColor
            '.TextureState(1).ColorOperation = TextureOperation.Disable
            '.TextureState(1).AlphaOperation = TextureOperation.Disable
            ' ----------------------------------------------------------------- COLORS
            '.RenderState.Lighting = True
            '.RenderState.SpecularEnable = True
            '.RenderState.LocalViewer = False
            '.RenderState.NormalizeNormals = True
            '.RenderState.DitherEnable = False
            '.RenderState.AmbientColor = Color.Red.ToArgb
            '.RenderState.Ambient = Color.Red
            '.SetRenderState(RenderStates.Ambient, Color.Red.ToArgb)

            '.RenderState.ShadeMode = ShadeMode.Phong
            '.RenderState.EmissiveMaterialSource = ColorSource.Material
            ' ----------------------------------------------------------------- VIDEO 1
            If AV1.m_Texture IsNot Nothing Then
                .SetRenderState(RenderStates.TextureFactor, Color.FromArgb(Red1, Green1, Blue1).ToArgb)
                .RenderState.AlphaBlendEnable = False
                .SetTexture(0, AV1.m_Texture)
                .VertexFormat = CustomVertex.TransformedTextured.Format
                .SetStreamSource(0, m_Vertices, 0)
                .DrawPrimitives(PrimitiveType.TriangleStrip, 0, 2)
            End If
            ' ----------------------------------------------------------------- VIDEO 2 
            If AV2.m_Texture IsNot Nothing Then
                .SetRenderState(RenderStates.TextureFactor, Color.FromArgb(Red2, Green2, Blue2).ToArgb)
                .RenderState.AlphaBlendEnable = True
                .RenderState.BlendOperation = BlendOperation.Add
                .RenderState.SourceBlend = Blend.SourceAlpha
                .RenderState.DestinationBlend = Blend.InvSourceAlpha
                .SetTexture(0, AV2.m_Texture)
                .VertexFormat = CustomVertex.TransformedTextured.Format
                .SetStreamSource(0, m_Vertices, 0)
                .DrawPrimitives(PrimitiveType.TriangleStrip, 0, 2)
            End If
            ' ----------------------------------------------------------------- 
            .EndScene()
            .Present()
        End With
    End Sub

End Class

